;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Coin Heaven by themilkman
;; Starts throwing coins upwards
;; 
;;
;; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;; RAM locations
	RAM_ExtraBits 		= $7FAB10
        RAM_NewSpriteNumber	= $7FAB9E
	
	;; JSL locations
	FindFreeSlotLowPri	= $02A9DE
	InitSpriteTables	= $07F7D2
	InitCustomSpriteTables  = $0187A7
	GetRand			= $01ACF9

	;; Variables
	Frequency = $12
	SpriteToGenerate = $21         ; Only used if first extra bit is clear
                    SOUND_EFFECT    = $01 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
        dcb "INIT"              ; Generators don't have an INIT routine
        dcb "MAIN"                                    
        PHB                     
        PHK                     
        PLB                     
        JSR GenerateSprite
        PLB                     
        RTL
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_02B153:        dcb $10,$18,$20,$28
DATA_02B157:        dcb $18,$1A,$1C,$1E

LDA #$12
STA $0DDA

GenerateSprite:
	LDA $14                   
        AND #Frequency
        BNE Return02B1B7          
        JSL FindFreeSlotLowPri  
        BMI Return02B1B7          
        TYX                       

NormalSprite:	
	LDA #SpriteToGenerate    
        STA $9E,X
        LDA #SOUND_EFFECT       ;play sound effect
        STA $1DFC              
        JSL InitSpriteTables
	BRA Shared

Shared:
	LDA #$08			; Sprite status = Normal 
        STA $14C8,X 			
        LDA $1C                   
        CLC                       
        ADC #$C0                
        STA $D8,X                 
        LDA $1D                   
        ADC #$00                
        STA $14D4,X             
        JSL GetRand             
        CMP #$00                
        PHP                       
        PHP                       
        AND #$03                
        TAY                       
        LDA DATA_02B153,Y       
        PLP                       
        BPL ADDR_02B196           
        EOR #$FF                
ADDR_02B196:
        CLC                       
        ADC $1A                   
        STA $E4,X                 
        LDA $1B                   
        ADC #$00                
        STA $14E0,X             
        LDA $148E               
        AND #$03                
        TAY                       
        LDA DATA_02B157,Y       
        PLP                       
        BPL ADDR_02B1B1           
        EOR #$FF                
        INC A                     
ADDR_02B1B1:
        STA $B6,X                 
        LDA #$B8                
        STA $AA,X                 
Return02B1B7:
	RTS                       ; Return 
